/* Name: iohardware.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-03-26
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#include <avr/wdt.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <compat/deprecated.h>





void iohrdwareinit(void)
{
DDRB=0xff;
DDRD=0x2;
 ACSR=_BV(ACD);
TCCR0B=_BV(CS01);
TIMSK=_BV(TOIE0);

UCSRC=_BV(UMSEL)|_BV(UPM1)|_BV(UCSZ1)|_BV(UCSZ0);

UBRRL=3;
UCSRB=_BV(RXEN)|_BV(UCSZ2)|_BV(RXCIE);
wdt_reset();
wdt_enable( WDTO_4S);
sei();
}