/* Name: led_matrix_control.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-03-26
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include <stdlib.h>
#include <avr/wdt.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <compat/deprecated.h>


#include "main.h"
#include "led_matrix_control.h"
#include "iohardware.h"


ISR(TIMER0_OVF_vect, ISR_NOBLOCK)
{
register uint8_t symbol,hlp_ind;
uint8_t brightLevel;
static volatile uint16_t count_a,countDot;
TCCR0B=0;

if (count_a==3)
	{
	count_a=0;
	countDot=8;
	}
else 
{
count_a++;
countDot>>=1;
}
if (count_a==0)
symbol=checked_Array[0];

if (count_a==1)
symbol=checked_Array[1];

if (count_a==2)
symbol=checked_Array[2];
if (count_a==3)
symbol=checked_Array[3];

ANODE_OFF;
SEG_OFF;
	
	if ((symbol&0x3f)>12) symbol=9;
		
		switch (symbol&0x0f)
			{
				case 0:
				{
					hlp_ind=0x3f;
					break;
				}
					case 1:
				{
					hlp_ind=0x06;
					break;
				}	
				case 2:
				{
					hlp_ind=0x5b;
					break;
				}	
				case 3:
				{
					hlp_ind=0x4f;
					break;
				}	
				case 4:
				{
					hlp_ind=0x66;
					break;
				}	
				case 5:
				{
					hlp_ind=0x6d;
					break;
				}	
				case 6:
				{
					hlp_ind=0x7d;
					break;
				}	
				case 7:
				{
					hlp_ind=0x07;
					break;
				}	
				case 8:
				{
					hlp_ind=0x7f;
					break;
				}
				case 9:
				{
					hlp_ind=0x6f;//-----
					break;
				}	
				
				case 10:
				{
				hlp_ind=0; //empty simbol
				break;
				}
				
				case 11:
				{
				hlp_ind=0x40;
				
				}
			}	
	if (hlp_ind&1) SEG_A;
	if (hlp_ind&2) SEG_B;
	if (hlp_ind&4) SEG_C;
	if (hlp_ind&8) SEG_D;
	if (hlp_ind&0x10) SEG_E;
	if (hlp_ind&0x20) SEG_F;
	if (hlp_ind&0x40) SEG_G;
	if (countDot&((0xF0&checked_Array[4])>>4)) SEG_DT;
	
	 
brightLevel=(0x0F&checked_Array[4])*14;	
if (brightLevel<1) brightLevel=1;

TCNT0=0;
OCR0A=brightLevel;
	switch (count_a)
	{
				case 0:
				{
					ANODE1_ON;
					break;
				}
					case 1:
				{
					ANODE2_ON;
					break;
				}	
				case 2:
				{
					ANODE3_ON;
					break;
				}	
				case 3:
				{
					ANODE4_ON;
					
				}	
	}






TCCR0B=_BV(CS01)|_BV(CS00);
Timer0flag=1;
}




ISR(TIMER0_COMPA_vect,  ISR_NAKED)
{
ANODE_OFF;
reti();
}