/* Name: ADC.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-04-06
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
/* 
ADC work
*/

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include <compat/deprecated.h>


#include "main.h"
#include "ADC.h"

ISR(ADC_vect)
{
static volatile uint8_t measureInput;
// Read fotoresistor value, set input to 2.56v reference voltage
if (measureInput==0)
	{
	POWER_MEASURE;
	data.bright=ADC>>6;
	if (data.bright>15) data.bright=15;
	if (data.bright<4) data.bright=4;
	data.bright=(20-data.bright-data.bright/4-data.bright/8-data.bright/8);
	

	}
// Read 2.56v reference voltage, check power voltage, set input sensor heater voltage
if (measureInput==1)
	{
	VOLTAGE_FEEDBACK;
	if (ADC>380) VoltageShutdown=1;
	else VoltageShutdown=0;

	}
// Read sensor heater voltage, set input to fotoresistor voltage
if (measureInput==2)
	{
	VoltageFeedback=ADC;
	LIGHT_LEVEL;
	
	}
if (measureInput<2) measureInput++;
else measureInput=0;	
sbi (ADCSRA,ADSC);
ADCcircleFlag=1;
}