/* Name: base_measure.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-04-06
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include <compat/deprecated.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/eeprom.h>


#include "main.h"
#include "base_measure.h"
#include "termo_measure.h"
#include "iohardware.h"

uint16_t e_base_coefficient __attribute__((section(".eeprom")));
uint8_t e_signOfWrited __attribute__((section(".eeprom")));


// function of calibrate sensor

int16_t base_measure(void)
{
int16_t deltaSensor;


if ((eeprom_read_byte(&e_signOfWrited)==0xaa)&&bit_is_set(PINB,5))
						deltaSensor=eeprom_read_word(&e_base_coefficient);
else 
	{
	int16_t boxTemperature, hotSensorTemperature;

	uint32_t time_delay;
	time_delay=clockTicks;
	while((clockTicks-time_delay)<5) watchDogReset();
	// measure sensor temperature without heater
	boxTemperature=readFilteredTemperature();
	data.comfortTemp=boxTemperature;
	
	
	// heater on and wait 10 minutes
	TCCR0=_BV(CS01);
	time_delay=clockTicks;
	while((clockTicks-time_delay)<600) watchDogReset();
	
	// measure hot sensor temperature
	hotSensorTemperature=readFilteredTemperature();

	deltaSensor=hotSensorTemperature-boxTemperature;
	data.comfortTemp=deltaSensor;
	TCCR0=0;
	SWITCH_OFF;
	// in case measurement error
	if (deltaSensor<10) deltaSensor=900;
	measureComfortTemperatureFlag=0;
	measureAirTemperatureFlag=0;
	eeprom_write_word(&e_base_coefficient,deltaSensor);
	eeprom_write_byte(&e_signOfWrited,0xaa);
	}

return deltaSensor;

}

