/* Name: clock_tick.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-04-06
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

/*
counting seconds, every 10 min set air temperature measure flag, every 30 min set windchill measurement flag,
set clock point, start transmit procedure
*/
#include <compat/deprecated.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include  <avr/sleep.h>


#include "main.h"
#include "iohardware.h"
#include "clock_tick.h"
#include "USI.h"

// clk = 4Mhz/128, circle = (OCR2=243 x 63 ticks + OCR2=250 x 1 tick)
ISR(TIMER2_COMP_vect)
{
static volatile uint8_t tick,comfortTemperat=6;
static volatile uint16_t airTemperat;
static volatile  uint16_t sum;

if (tick>62)
	{
	uint8_t check;
	
	OCR2=250;
	if (clockTicks<86400) clockTicks++;
	else clockTicks=0;
	// save time counter in independent memory cell and calculate checksum
	*p_clockticks=clockTicks;

	check=clockTicks;
	check^=clockTicks>>8;
	check^=clockTicks>>16;
	check^=clockTicks>>24;
	*p_checkSum=check;
	
	tick=0;
	if (VoltageShutdown==0)
		{
		data.clockPoint^=1;
		if (BUTTON_UP||BUTTON_DOWN) 
			{
			sum=Set_Time (&clockTicks,sum);
			 if (sum>64000) sum=64000;
			}
		
		if (airTemperat>600) 
			{
			airTemperat=0;
			measureAirTemperatureFlag=1;
			if (comfortTemperat>2) 
				{
				comfortTemperat=0;
				measureComfortTemperatureFlag=1;
				}
			else comfortTemperat++;
			}
		else airTemperat++;
		
			
				time_calculator(&data,&clockTicks);
				
				transmitDataStructure(&data);
				
		
		}
	}
	
else 
	{
	if ((tick==15||tick==30||tick==45)&&VoltageShutdown==0)
		{
		if (BUTTON_UP||BUTTON_DOWN) 
				{
				sum=Set_Time (&clockTicks,sum);
				 if (sum>64000) sum=64000;
				 
				 time_calculator(&data,&clockTicks);
				 
				data.clockPoint=1;
				
				transmitDataStructure(&data);
				 
				}
		
				
		}		
	
	OCR2=243;
	tick++;
	}

if ((bit_is_set(PIND,6))&&(bit_is_set(PIND,5))) sum=60;

//cbi(PORTB,1);
timer2CircleFlag=1;
timeFlagADC=1;
}


void time_calculator (struct dataIndic* aData,volatile uint32_t *p_clockTicks)
{
uint16_t secondsRemainder;
aData->hour=clockTicks/3600;

secondsRemainder=clockTicks%3600;
aData->minutes=secondsRemainder/60;

}


uint16_t  Set_Time (volatile uint32_t *aDayTicks,uint16_t sum)
{

if (BUTTON_UP)
	{
	
	*aDayTicks+=sum;
	if (*aDayTicks>86400) *aDayTicks=0;

	
	}
if (BUTTON_DOWN)
	{
	
	*aDayTicks-=sum;
	if (*aDayTicks>86400) *aDayTicks=86400;

	
	}
	if (sum<600) sum+=60;
	else sum+=600;
return sum;

}