/* Name: iohardware.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-03-19
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include <compat/deprecated.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include  <avr/sleep.h>
#include <avr/wdt.h>

#include "main.h"
#include "iohardware.h"
#include "1-wire.h"
#include "termo_measure.h"
#include "USI.h"
#include "ADC.h"

// start initialization 

void iohardwareInit(void)
{
	
	
	sbi(DDRB,1);
	sbi(DDRD,1);
	sbi(DDRD,4);
	sbi(PORTB,3);
	USIinit();
	OCR2=247;
	TCCR2=_BV(WGM21)|_BV(CS22)|_BV(CS21);
	TIMSK=_BV(OCIE2)|_BV(TOIE0);
//	TIMSK=_BV(OCIE2);
	LIGHT_LEVEL;
	ADCSRA=_BV(ADPS1)|_BV(ADPS2)|_BV(ADIE)|_BV(ADSC)|_BV(ADEN); 
	ACSR=_BV(ACD);
	wdt_reset();
	wdt_enable(WDTO_2S);
	sei();
}

// set energy saving mode, when powered from lithium battery

void iohardwareDeInit (void)
{
	cli();
	wdt_disable();
	USIDeInit();
	TCCR0=0;
	TCCR1A=0;
	TCCR1B=0;
	TIMSK=_BV(OCIE2);
	ADCSRA=0;
	cbi(DDRB,1);
	cbi(DDRD,1);
	cbi(DDRD,4);
	cbi(PORTB,3);
	sei();
}