/* Name: voltage_stabilizer.c
 * Project: Comfort_termometer
 * Author: Sergey Merkulov <merk71@rambler.ru>
 * Creation Date: 2011-03-26
 * Tabsize: 4
 * Copyright: (c) 2011 by Sergey Merkulov, all rights reserved.
 * License: GNU GPL v3 (see COPYING.txt) 
 *
 * This file is part of Comfort_termometer.
 *
 *   Comfort_termometer is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Comfort_termometer is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Comfort_termometer.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */


/* 
function stabilize value=
Vrms^2=Vavr*Vavr*Tperiod/Tpulse
this give constant power heater
call freq 122Hz
*/

#include <compat/deprecated.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "main.h"
#include "iohardware.h"
#include "voltage_stabilizer.h"

ISR(TIMER0_OVF_vect)
{
static volatile uint8_t circleCounter,timeONSwitch,circleRegulator;

	{
	if (circleCounter<15) circleCounter++;
	else 
		{
		circleCounter=0;
		if (circleRegulator) circleRegulator--;
		else
			{
			timeONSwitch=VoltageRegulator();
		
			circleRegulator=15;
			}
		
		}

	if (timeONSwitch>circleCounter) SWITCH_ON;
	else SWITCH_OFF;
	}
}

uint8_t VoltageRegulator(void)
{
static int8_t regulatorOut;
int16_t err,VrmsSquad;
static int16_t sumI;

VrmsSquad=((uint32_t)VoltageFeedback*15*VoltageFeedback/32)/2/regulatorOut; 
	
		err=400-VrmsSquad;
	
			sumI+=err;
			if (sumI>32000)
				sumI=32000;
			if (sumI<0)
				sumI=0;

regulatorOut=sumI/2046;
		if (regulatorOut>15)
			regulatorOut=15;
		if (regulatorOut<0)
			regulatorOut=0;
timer0CircleFlag=1;

return regulatorOut;
}